/*
 *  DEBUG, {akii-root}/src/debug.c
 *
 * ==========================================================================
 *
 *                      Arena Kliens II. Releases
 *
 * ==========================================================================
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
 *
 * A legkiralyabb szovegszerkeszto: VIM - Vi IMproved 5  <http://www.vim.org>
 */

#include <stdio.h>
#include "debug.h"
#define RECMAX 1024

FILE *dbgfp = NULL;

int dbg[dbg_last + 1];
char sdbg[dbg_last][20];
int lastfv = 0, dbgfv[RECMAX] =
{-1};

char dbgconst[dbg_last][20] =
{
/*variables.c */
    "getvar",
    "getvarifp",
    "getnumvar",
    "parsedollar",
    "dollar",
    "braces",
    "freevarlist",
    "freenumvarlist",
    "setvar",
    "setnvar",
    "gettoretlen",
    "freeonlist",
    "freetimerlist",
/*expression.c */
    "getoperand",
    "dokif",
    "readkif",
    "readkiffv",
    "readkifop",
    "milyenkifez",
    "readkifinfix",
    "freeinfkif",
    "mkpostfix",
    "freekiffa",
    "mkkiffa",
    "dtos",
    "_valamilyen_op",
/*interpreter.h */
    "freepar",
    "read_timer",
    "read_on",
    "read_return",
    "read_do",
    "read_while",
    "read_else",
    "read_if",
    "read_for",
    "read_foreach",
    "read_alias",
    "read_brkcnt",
    "read_kif",
    "milyenparancs",
    "do_alias",
    "do_if",
    "do_return",
    "do_do",
    "do_while",
    "do_for",
    "do_foreach",
    "do_on",
    "do_timer",
    "dooneparancs",
    "doparancssor",
    "readparancs",
/*commands.c */
    "callfv",
/*regexp.c */
    "regprobal",
    "regszavak",
    "regqszavak",
/*screen.c */
    "parsestatus",
/*main.c */
    "elemez",
    "sendline",
    "szin",
    "lookfortimers",
    "loadakiirc",
    "read_checkpoint",
    "do_checkpoint",
    "KILEPES",
    "SIGNAL"
};

void writedbg(int fv)
{
    int i;

    fseek(dbgfp, 0, SEEK_SET);
    fwrite(dbg, sizeof(dbg), 1, dbgfp);
#ifdef AKII_DEBUG_RESZLETES
    fwrite(sdbg, sizeof(sdbg), 1, dbgfp);
#endif
    fflush(dbgfp);
    return;
}

void startdbg(void)
{
    dbgfp = fopen("akii.dbg", "w+");
    memset(dbg, 0, sizeof(dbg));
    memset(sdbg, 0, sizeof(sdbg));
    writedbg(30000);
    return;
}
void closedbg(void)
{
    if (!dbgfp)
	return;
    fclose(dbgfp);
    dbgfp = NULL;
    return;
}
void dbgenter(int fv, char *megj)
{
    int i;

    if (!dbgfp)
	return;
    dbg[fv]++;
    dbgfv[++lastfv] = fv;
#ifdef AKII_DEBUG_RESZLETES
    if (megj) {
	strncpy(sdbg[fv], megj, 20);
	sdbg[fv][19] = 0;
	for (i = 0; i < 20; i++) {
	    if (!sdbg[fv][i])
		break;
	    if (sdbg[fv][i] < 32)
		sdbg[fv][i] = 32;
	}
    }
    else
	sdbg[fv][0] = 0;
#endif
    dbg[dbg_last] = fv;
    writedbg(fv);
    return;
}
void dbgleave(int fv)
{
    if (!dbgfp)
	return;
    dbg[fv]--;
#ifdef AKII_DEBUG_RESZLETES
    sdbg[fv][0] = 0;
#endif
    dbg[dbg_last] = dbgfv[--lastfv];
    writedbg(-fv);
    return;
}
